Prefix

Typedefs | Functions
Prefix
Eina » Tools

This group discusses the functions that provide the ability to determine the runtime location of a software package. More...

## Typedefs
typedef struct _Eina_Prefix | Eina_Prefix
| An opaque type for prefix handle. More...

## Functions
EINA_API Eina_Prefix * | eina_prefix_new (const char *argv0, void *symbol, const char *envprefix, const char *sharedir, const char *magicsharefile, const char *pkg_bin, const char *pkg_lib, const char *pkg_data, const char *pkg_locale)
| Creates a new prefix handle given that some input information is provided. More...
EINA_API void | eina_prefix_free (Eina_Prefix *pfx)
| Frees the prefix object and all its contents. More...
EINA_API const char * | eina_prefix_get (Eina_Prefix *pfx)
| Gets the prefix base directory. More...
EINA_API const char * | eina_prefix_bin_get (Eina_Prefix *pfx)
| Gets the binary installation directory. More...
EINA_API const char * | eina_prefix_lib_get (Eina_Prefix *pfx)
| Gets the library installation directory. More...
EINA_API const char * | eina_prefix_data_get (Eina_Prefix *pfx)
| Gets the data installation directory. More...
EINA_API const char * | eina_prefix_locale_get (Eina_Prefix *pfx)
| Gets the locale installation directory. More...

## Detailed Description

This group discusses the functions that provide the ability to determine the runtime location of a software package.

Since
  1.1.0

## Typedef Documentation

## ◆ Eina_Prefix

Eina_Prefix

An opaque type for prefix handle.

This is a prefix object that is returned by eina_prefix_new() when trying to determine the runtime location of the software in question so that other data files such as images, sound files, other executable utilities, libraries, modules, and locale files can be found.

Since
  1.1.0

## Function Documentation

## ◆ eina_prefix_new()

EINA_API Eina_Prefix* eina_prefix_new | ( | const char * | argv0,
|  | void * | symbol,
|  | const char * | envprefix,
|  | const char * | sharedir,
|  | const char * | magicsharefile,
|  | const char * | pkg_bin,
|  | const char * | pkg_lib,
|  | const char * | pkg_data,
|  | const char * | pkg_locale
| ) |  |

Creates a new prefix handle given that some input information is provided.

Parameters

  [in] | argv0 | If this is an executable this is argv[0] of the binary, otherwise `NULL` if it is used from a shared library
  [in] | symbol | A symbol (function for example) inside the binary or library to find the source location of, provide `NULL` if not used
  [in] | envprefix | The prefix to any environment variable that may override prefix detection and give the exact location of the software
  [in] | sharedir | The directory inside the standard share or data dir where the software stores data files
  [in] | magicsharefile | A magic file to check existence of and determine whether the prefix found is correct, and it must be located in the data dir under the share dir provided above, or `NULL` if the check is not to be done
  [in] | pkg_bin | The compile-time binary install dir
  [in] | pkg_lib | The compile-time library install dir
  [in] | pkg_data | The compile-time share/data install dir
  [in] | pkg_locale | The compile-time locale install dir

Returns
  The prefix handle, otherwise `NULL` on failure

Applications and libraries are most often not just single executables nor single shared library binaries, but also come with extra modules that they have to load, extra binary utilities they need to run, or have data files that they need to load. A very primitive application ASSUMES a fixed install location at compile-time, but this disallows the ability to relocate the application (or library) somewhere else after compilation (if you run out of space on a given disk, partition, etc. for example), or necessitate the need for having to maintain environment variables for every piece of software to let it know its location, or have to use large sets of symlinks pointing from the compiled location to the new one.

Being relocatable at runtime allows much easier distribution and installation into places like the users own home directory, instead of on a system partition, if the developer wishes for easier distribution of pre-compiled binaries.

The prefix system is designed to locate where the given software is installed (under a common prefix) at runtime and then report specific locations of this prefix and common directories inside this prefix like the binary, library, data, and locale directories.

To do this some information needs to be provided to eina_prefix_new(). If you have developed a binary executable, then provide argv[0] as the argv0 argument. This plus the PATH environment variable helps the prefix system to determine its location. Call eina_prefix_new() early on before you change the working directory or anything about argv[0], so it gets accurate information. It uses the first argument, being the executable itself, to look in absolute directories, relative paths, and PATH to see if it finds the right executable to determine just where the actual binary is installed and being run from. If you develop a shared library, just pass `NULL` as argv0.

Note
  It would prefer to use the symbol function to determine the location as that function is unique inside the application and try and trace back which file this function comes from (be it a binary or shared library) as this avoids more expensive searches via argv0. It uses this symbol if given in preference to argv0.
  The envprefix parameter provides a string prefix to prepend before environment variables to allow a fallback to specific environment variables to locate the software. For example, if "MYAPP" is provided as the prefix, then it uses "MYAPP_PREFIX" as a master environment variable to specify the exact install prefix for the software, or more specific environment variables like "MYAPP_BIN_DIR", "MYAPP_LIB_DIR", "MYAPP_DATA_DIR", and "MYAPP_LOCALE_DIR", which can be set by the user or scripts before launching. If not provided (NULL) environment variables are not used to override compiled-in defaults or auto detections.
  The sharedir string provides a subdirectory inside the system shared data dir for data files. For example, if the system dir is /usr/local/share then this dir name is appended, creating /usr/local/share/appname if this dir is the "appname" string. It is expected that the application or library installs data files in this directory.
  The magicsharefile is a filename or path of something inside the share or data dir to be used to test that the prefix detection worked. For example, your app installs a wallpaper image as /usr/local/share/appname/images/wallpaper.jpg and so to check that this worked, provide "images/wallpaper.jpg" as the magicsharefile string so detection can know if it worked or not.
  The pkg_bin, pkg_lib, pkg_data, and pkg_locale are compile-time strings (the kind standard autoconf/automake define) to be passed in so that there can be a fallback to compiled-in defaults as well as use them to determine actual names of directories like libdirs maybe changing to be lib32 or lib64 instead of lib, and so on.

Compile the following defining at compile time your prefixes like (example):

gcc appname.c -o appname -DPACKAGE_BIN_DIR=\"/usr/local/bin\" -DPACKAGE_LIB_DIR=\"/usr/local/lib\" -DPACKAGE_DATA_DIR=\"/usr/local/share/appname\" -DLOCALE_DIR=\"/usr/local/share/locale\" `pkg-config --cflags --libs eina`

(of course add appropriate compile flags to linking and note that locale dir is optional. If you don't need it, provide data dir as the locale dir. Also note that the magicsharefile is optional for testing and ensuring that the prefix check is correct. This file must be installed in the application data dir (e.g. /usr/local/share/appname) and be referred to using a unix-style relative path from that dir, e.g. directory/filename.png)

#include <Eina.h>
static Eina_Prefix *pfx = NULL;
int main(int argc, char **argv)
{
eina_init();
pfx = eina_prefix_new(argv[0], main, "APPNAME", "appname", NULL,
PACKAGE_BIN_DIR, PACKAGE_LIB_DIR,
PACKAGE_DATA_DIR, LOCALE_DIR);
if (!pfx) printf("ERROR: Critical error in finding prefix\n");
printf("install prefix is: %s\n", eina_prefix_get(pfx));
printf("binaries are in: %s\n", eina_prefix_bin_get(pfx));
printf("libraries are in: %s\n", eina_prefix_lib_get(pfx));
printf("data files are in: %s\n", eina_prefix_data_get(pfx));
eina_prefix_free(pfx);
eina_shutdown();
}
Eina.h
Eina Utility library.
eina_shutdown
EINA_API int eina_shutdown(void)
Shuts down the Eina library.
Definition: eina_main.c:379
eina_init
EINA_API int eina_init(void)
Initializes the Eina library.
Definition: eina_main.c:291
eina_prefix_lib_get
EINA_API const char * eina_prefix_lib_get(Eina_Prefix *pfx)
Gets the library installation directory.
Definition: eina_prefix.c:782
eina_prefix_get
EINA_API const char * eina_prefix_get(Eina_Prefix *pfx)
Gets the prefix base directory.
Definition: eina_prefix.c:768
eina_prefix_new
EINA_API Eina_Prefix * eina_prefix_new(const char *argv0, void *symbol, const char *envprefix, const char *sharedir, const char *magicsharefile, const char *pkg_bin, const char *pkg_lib, const char *pkg_data, const char *pkg_locale)
Creates a new prefix handle given that some input information is provided.
Definition: eina_prefix.c:468
Eina_Prefix
struct _Eina_Prefix Eina_Prefix
An opaque type for prefix handle.
Definition: eina_prefix.h:26
eina_prefix_free
EINA_API void eina_prefix_free(Eina_Prefix *pfx)
Frees the prefix object and all its contents.
Definition: eina_prefix.c:754
eina_prefix_bin_get
EINA_API const char * eina_prefix_bin_get(Eina_Prefix *pfx)
Gets the binary installation directory.
Definition: eina_prefix.c:775
eina_prefix_data_get
EINA_API const char * eina_prefix_data_get(Eina_Prefix *pfx)
Gets the data installation directory.
Definition: eina_prefix.c:789

Since
  1.1.0

See also
  eina_prefix_free()

References alloca(), DBG, EINA_FALSE, eina_file_path_join(), EINA_PATH_SEP_C, EINA_PATH_SEP_S, EINA_SAFETY_ON_NULL_RETURN_VAL, EINA_TRUE, INF, realpath(), and WRN.

Referenced by ecore_init(), elm_quicklaunch_init(), and elua_init().

## ◆ eina_prefix_free()

EINA_API void eina_prefix_free | ( | Eina_Prefix * | pfx | ) |

Frees the prefix object and all its contents.

Parameters

  [in] | pfx | The prefix object

This function frees the prefix object and all its allocated content. It is invalid to access the object after it is freed.

Since
  1.1.0

See also
  eina_prefix_new()

References EINA_SAFETY_ON_NULL_RETURN.

Referenced by elm_quicklaunch_shutdown(), elua_shutdown(), and emotion_shutdown().

## ◆ eina_prefix_get()

EINA_API const char* eina_prefix_get | ( | Eina_Prefix * | pfx | ) |

Gets the prefix base directory.

Parameters

  [in] | pfx | The prefix object

Returns
  The base prefix (e.g. "/usr/local", "/usr", "/opt/appname" or "/home/user/myapps/appname", etc.) that the software resides in at runtime

Since
  1.1.0

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by elm_app_prefix_dir_get().

## ◆ eina_prefix_bin_get()

EINA_API const char* eina_prefix_bin_get | ( | Eina_Prefix * | pfx | ) |

Gets the binary installation directory.

Parameters

  [in] | pfx | The prefix object

Returns
  The location of installed binaries (e.g. "/usr/local/bin", "/usr/bin", "/opt/appname/bin", "/home/user/myapps/appname/bin" etc.)

Since
  1.1.0

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by elm_app_bin_dir_get().

## ◆ eina_prefix_lib_get()

EINA_API const char* eina_prefix_lib_get | ( | Eina_Prefix * | pfx | ) |

Gets the library installation directory.

Parameters

  [in] | pfx | The prefix object

Returns
  The location of installed binaries (e.g. "/usr/local/lib", "/usr/lib32", "/opt/appname/lib64", "/home/user/myapps/appname/lib" etc.)

Since
  1.1.0

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by elm_app_lib_dir_get(), and elm_quicklaunch_init().

## ◆ eina_prefix_data_get()

EINA_API const char* eina_prefix_data_get | ( | Eina_Prefix * | pfx | ) |

Gets the data installation directory.

Parameters

  [in] | pfx | The prefix object

Returns
  The location of installed binaries (e.g. "/usr/local/share/appname", "/usr/share/appname", "/opt/appname/share/appname", "/home/user/myapps/appname/share/appname" etc.)

Since
  1.1.0

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by elm_app_data_dir_get(), and elm_quicklaunch_init().

## ◆ eina_prefix_locale_get()

EINA_API const char* eina_prefix_locale_get | ( | Eina_Prefix * | pfx | ) |

Gets the locale installation directory.

Parameters

  [in] | pfx | The prefix object

Returns
  The location of installed binaries (e.g. "/usr/local/share/locale", "/usr/share/locale", "/opt/appname/share/locale", "/home/user/myapps/appname/share/locale" etc.)

Since
  1.1.0

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by elm_app_locale_dir_get().